#include <stdio.h>
#include <windows.h>
#include <commctrl.h>

#define CLASSNAME "MetricsClass"

HWND ctlstatic[SM_CMETRICS + 1], ctledit[SM_CMETRICS + 1], ctlbutton[2];
int x, y, width, height, ctlbuttonid[2];

const char *metricNames[SM_CMETRICS + 1] =
{"SM_CXSCREEN",
 "SM_CYSCREEN",
 "SM_CXVSCROLL",
 "SM_CYHSCROLL",
 "SM_CYCAPTION",
 "SM_CXBORDER",
 "SM_CYBORDER",
 "SM_CXDLGFRAME",
 "SM_CYDLGFRAME",
 "SM_CYVTHUMB",
 "SM_CXHTHUMB",
 "SM_CXICON",
 "SM_CYICON",
 "SM_CXCURSOR",
 "SM_CYCURSOR",
 "SM_CYMENU",
 "SM_CXFULLSCREEN",
 "SM_CYFULLSCREEN",
 "SM_CYKANJIWINDOW",
 "SM_MOUSEPRESENT",
 "SM_CYVSCROLL",
 "SM_CXHSCROLL",
 "SM_DEBUG",
 "SM_SWAPBUTTON",
 "SM_RESERVED1",
 "SM_RESERVED2",
 "SM_RESERVED3",
 "SM_RESERVED4",
 "SM_CXMIN",
 "SM_CYMIN",
 "SM_CXSIZE",
 "SM_CYSIZE",
 "SM_CXFRAME",
 "SM_CYFRAME",
 "SM_CXMINTRACK",
 "SM_CYMINTRACK",
 "SM_CXDOUBLECLK",
 "SM_CYDOUBLECLK",
 "SM_CXICONSPACING",
 "SM_CYICONSPACING",
 "SM_MENUDROPALIGNMENT",
 "SM_PENWINDOWS",
 "SM_DBCSENABLED",
 "SM_CMOUSEBUTTONS",
 "SM_CXFIXEDFRAME",
 "SM_CYFIXEDFRAME",
 "SM_CXSIZEFRAME",
 "SM_CYSIZEFRAME",
 "SM_SECURE",
 "SM_CXEDGE",
 "SM_CYEDGE",
 "SM_CXMINSPACING",
 "SM_CYMINSPACING",
 "SM_CXSMICON",
 "SM_CYSMICON",
 "SM_CYSMCAPTION",
 "SM_CXSMSIZE",
 "SM_CYSMSIZE",
 "SM_CXMENUSIZE",
 "SM_CYMENUSIZE",
 "SM_ARRANGE",
 "SM_CXMINIMIZED",
 "SM_CYMINIMIZED",
 "SM_CXMAXTRACK",
 "SM_CYMAXTRACK",
 "SM_CXMAXIMIZED",
 "SM_CYMAXIMIZED",
 "SM_NETWORK",
 "SM_CLEANBOOT",
 "SM_CXDRAG",
 "SM_CYDRAG",
 "SM_SHOWSOUNDS",
 "SM_CXMENUCHECK",
 "SM_CYMENUCHECK",
 "SM_SLOWMACHINE",
 "SM_MIDEASTENABLED",
 "SM_MOUSEWHEELPRESENT",
 "SM_XVIRTUALSCREEN",
 "SM_YVIRTUALSCREEN",
 "SM_CXVIRTUALSCREEN",
 "SM_CYVIRTUALSCREEN",
 "SM_CMONITORS",
 "SM_SAMEDISPLAYFORMAT",
 "SM_IMMENABLED",
 "SM_CXFOCUSBORDER",
 "SM_CYFOCUSBORDER",
 "SM_TABLETPC",
 "SM_MEDIACENTER",
 "SM_CMETRICS"};

void UpdateMetricItems(HWND hwnd)
{
  int i;
  char s[11];

  for (i = 0; i <= SM_CMETRICS; ++i)
  {
    sprintf(s, "%d", GetSystemMetrics(i));
    SendMessage(ctledit[i], WM_SETTEXT, 0, (long) s);
  }

  UpdateWindow(hwnd);

  return;
}

void CreateButtons(HWND hwnd)
{
  ctlbutton[0] = CreateWindow("BUTTON", "Refresh",
                              WS_VISIBLE | WS_CHILD
                              | BS_DEFPUSHBUTTON | BS_TEXT,
                              0, 3, width / 4, 30,
                              hwnd, (HMENU) NULL,
                              (HINSTANCE) NULL, (LPVOID) NULL);
  ctlbuttonid[0] = GetDlgCtrlID(ctlbutton[0]);

  ctlbutton[1] = CreateWindow("BUTTON", "Save",
                              WS_VISIBLE | WS_CHILD
                              | BS_PUSHBUTTON | BS_TEXT,
                              width / 4 + 1, 3, width / 4, 30,
                              hwnd, (HMENU) NULL,
                              (HINSTANCE) NULL, (LPVOID) NULL);
  ctlbuttonid[1] = GetDlgCtrlID(ctlbutton[1]);

  return;
}

void CreateMetricItems(HWND hwnd)
{
  int i, j, ix, iy;

  iy = 3 + 30 + 3;
  for (i = 0; i <= SM_CMETRICS; )
  {
    ix = 0;
    for (j = 0; (j < 4 && i <= SM_CMETRICS); ++j, ++i)
    {
      ctlstatic[i] = CreateWindow("STATIC", metricNames[i],
                                  SS_LEFT | WS_CHILD | WS_VISIBLE,
                                  ix, iy + 1, 150, 18,
                                  hwnd, NULL, NULL, NULL);

      ctledit[i] = CreateWindow("EDIT", "",
                                WS_CHILD | WS_BORDER | WS_VISIBLE
                                | ES_RIGHT | ES_NUMBER | ES_READONLY,
                                ix + 140, iy, 50, 20,
                                hwnd, (HMENU) (NULL),
                                (HINSTANCE) NULL, (LPVOID) NULL);

      ix += 200;
    }

    iy += 22;
  }

  UpdateMetricItems(hwnd);

  return;
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  switch(msg)
  {
    case WM_CREATE:
      CreateButtons(hwnd);
      CreateMetricItems(hwnd);
    break;
    case WM_CLOSE:
      DestroyWindow(hwnd);
    break;
    case WM_DESTROY:
      PostQuitMessage(0);
    break;
    case WM_COMMAND:
      if (HIWORD(wParam) == BN_CLICKED)
        UpdateMetricItems(hwnd);
if (LOWORD(wParam) == ctlbuttonid[0])
printf("Refresh\n");
printf("%d %d\n", ctlbuttonid[0], ctlbuttonid[1]);
getc(stdin);
    break;
    default:
      return DefWindowProc(hwnd, msg, wParam, lParam);
  }
  return 0;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine, int nCmdShow)
{
  WNDCLASS wc;
  HWND hwnd;
  MSG Msg;

  wc.style = 0;
  wc.lpfnWndProc = WndProc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  wc.hInstance = hInstance;
  wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH) (COLOR_WINDOW);
  wc.lpszMenuName = NULL;
  wc.lpszClassName = CLASSNAME;

  RegisterClass(&wc);

  width = 4 * 200;
  height = (((SM_CMETRICS + 1) / 4) + 1) * 22 + 3 + 30 + 3
           + GetSystemMetrics(SM_CYCAPTION) + 2 * GetSystemMetrics(SM_CYFRAME);

  x = (GetSystemMetrics(SM_CXSCREEN) - width) / 2;
  y = (GetSystemMetrics(SM_CYSCREEN) - height) / 2;

  hwnd = CreateWindow(
    CLASSNAME,
    "Metrics",
    WS_OVERLAPPEDWINDOW,
    CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
    NULL, NULL, hInstance, NULL);

  MoveWindow(hwnd, x, y, width, height,FALSE);

  ShowWindow(hwnd, nCmdShow);

  while(GetMessage(&Msg, NULL, 0, 0) > 0)
  {
    TranslateMessage(&Msg);
    DispatchMessage(&Msg);
  }

  return Msg.wParam;
}

